org.apache.poi.xssf.model

## Interface SharedStrings

- All Known Implementing Classes:
    ReadOnlySharedStringsTable, SharedStringsTable, XSSFBSharedStringsTable

      public interface SharedStrings

  Table of strings shared across all sheets in a workbook.

  A workbook may contain thousands of cells containing string (non-numeric) data. Furthermore this data is very likely to be repeated across many rows or columns. The goal of implementing a single string table that is shared across the workbook is to improve performance in opening and saving the file by only reading and writing the repetitive information once.

  Consider for example a workbook summarizing information for cities within various countries. There may be a column for the name of the country, a column for the name of each city in that country, and a column containing the data for each city. In this case the country name is repetitive, being duplicated in many cells. In many cases the repetition is extensive, and a tremendous savings is realized by making use of a shared string table when saving the workbook. When displaying text in the spreadsheet, the cell table will just contain an index into the string table as the value of a cell, instead of the full string.

  The shared string table contains all the necessary information for displaying the string: the text, formatting properties, and phonetic properties (for East Asian languages).

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getCount()` Return an integer representing the total count of strings in the workbook.
    `RichTextString` | `getItemAt(int idx)` Return a string item by index
    `int` | `getUniqueCount()` Returns an integer representing the total count of unique strings in the Shared String Table.

- - ### Method Detail

    - #### getItemAt

          RichTextString getItemAt(int idx)

      Return a string item by index
      Parameters:
        `idx` - index of item to return.
      Returns:
        the item at the specified position in this Shared String table.

    - #### getCount

          int getCount()

      Return an integer representing the total count of strings in the workbook. This count does not include any numbers, it counts only the total of text strings in the workbook.
      Returns:
        the total count of strings in the workbook

    - #### getUniqueCount

          int getUniqueCount()

      Returns an integer representing the total count of unique strings in the Shared String Table. A string is unique even if it is a copy of another string, but has different formatting applied at the character level.
      Returns:
        the total count of unique strings in the workbook

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.